diff -r 11a8f1275a38 sys/netinet/tcp_input.c
--- a/sys/netinet/tcp_input.c	Mon Jul 16 20:17:19 2012 +0000
+++ b/sys/netinet/tcp_input.c	Mon Mar 11 02:59:51 2013 +1100
@@ -2408,7 +3151,7 @@
 						
 						/*
 						 * Compute the amount of data in flight first.
-						 * We can inject new data into the pipe iff 
+						 * We can inject new data into the pipe if
 						 * we have less than 1/2 the original window's
 						 * worth of data in flight.
 						 */
@@ -2419,13 +3162,13 @@
 							if (tp->snd_cwnd > tp->snd_ssthresh)
 								tp->snd_cwnd = tp->snd_ssthresh;
 						}
-					} else
+					} else {		// duplicate acks
 						tp->snd_cwnd += tp->t_maxseg;
+					}
 					(void) tcp_output(tp);
 					goto drop;
 				} else if (tp->t_dupacks == tcprexmtthresh) {
 					tcp_seq onxt = tp->snd_nxt;
-
 					/*
 					 * If we're doing sack, check to
 					 * see if we're already in sack
@@ -2488,6 +3231,12 @@
 					    tp->t_maxseg;
 					(void) tcp_output(tp);
 					sent = tp->snd_max - oldsndmax;
+
+//					printf("limited transmit: oldcwnd: %lu, snd_cwnd: %lu, snd_wnd: %lu, dupacks %d, snd_limited %d, "
+//							"sent %u, snd_nxt: %u, snd_max: %u \n\n",
+//							oldcwnd, tp->snd_cwnd, tp->snd_wnd, tp->t_dupacks,
+//							tp->snd_limited, sent, tp->snd_nxt , tp->snd_max);
+
 					if (sent > tp->t_maxseg) {
 						KASSERT((tp->t_dupacks == 2 &&
 						    tp->snd_limited == 0) ||
@@ -2537,6 +3286,7 @@
 			 */
 			tp->t_flags &= ~TF_NEEDSYN;
 			tp->snd_una++;
+
 			/* Do window scaling? */
 			if ((tp->t_flags & (TF_RCVD_SCALE|TF_REQ_SCALE)) ==
 				(TF_RCVD_SCALE|TF_REQ_SCALE)) {
@@ -2616,18 +3366,14 @@
 		 */
 		cc_ack_received(tp, th, CC_ACK);
 
-		SOCKBUF_LOCK(&so->so_snd);
-		if (acked > so->so_snd.sb_cc) {
-			tp->snd_wnd -= so->so_snd.sb_cc;
-			sbdrop_locked(&so->so_snd, (int)so->so_snd.sb_cc);
+		if ((tp->t_flags & TF_SENTFIN) && (th->th_ack == tp->snd_max)) {
+			tp->snd_wnd -= ulmin(tp->snd_wnd, acked);
 			ourfinisacked = 1;
 		} else {
-			sbdrop_locked(&so->so_snd, acked);
 			tp->snd_wnd -= acked;
 			ourfinisacked = 0;
 		}
-		/* NB: sowwakeup_locked() does an implicit unlock. */
-		sowwakeup_locked(so);
+
 		/* Detect una wraparound. */
 		if (!IN_RECOVERY(tp->t_flags) &&
 		    SEQ_GT(tp->snd_una, tp->snd_recover) &&
@@ -2639,6 +3385,13 @@
 			EXIT_RECOVERY(tp->t_flags);
 		}
 		tp->snd_una = th->th_ack;
+
+		/* XXX this is a temp hack, must be changed */
+		if (tp->t_mpcb->direct_map) {
+			atomic_subtract_int(&so->so_snd.sb_cc, acked - (ourfinisacked ? 1 : 0));
+		}
+		tcp_ackmap(tp, th);
+
 		if (tp->t_flags & TF_SACK_PERMIT) {
 			if (SEQ_GT(tp->snd_una, tp->snd_recover))
 				tp->snd_recover = tp->snd_una;
@@ -2667,7 +3420,11 @@
 				 * compressed state.
 				 */
 				if (so->so_rcv.sb_state & SBS_CANTRCVMORE) {
-					soisdisconnected(so);
+					// call into mptcp layer function to do this
+					// are any subflows in state < TCPS_FIN_WAIT_2
+					// if so then skip past the soisdisconnected (in fact soisdiconnected
+					// called from the mp_layer function
+
 					tcp_timer_activate(tp, TT_2MSL,
 					    (tcp_fast_finwait2_recycle ?
 					    tcp_finwait2_timeout :
@@ -2712,6 +3469,10 @@
 step6:
 	INP_WLOCK_ASSERT(tp->t_inpcb);
 
+//	if((tp->t_mpcb->mp_state == MPS_PRE_ESTABLISHED) &&
+//			(thflags & (TH_SYN|TH_ACK)) == TH_ACK)
+//		mp_init_established(tp);
+
 	/*
 	 * Update window information.
 	 * Don't look at window if no ACK: TAC's send garbage on first SYN.
@@ -2744,7 +3505,7 @@
 		 * actually wanting to send this much urgent data.
 		 */
 		SOCKBUF_LOCK(&so->so_rcv);
-		if (th->th_urp + so->so_rcv.sb_cc > sb_max) {
+		if (th->th_urp + (so->so_rcv.sb_cc) > sb_max) {
 			th->th_urp = 0;			/* XXX */
 			thflags &= ~TH_URG;		/* XXX */
 			SOCKBUF_UNLOCK(&so->so_rcv);	/* XXX */
@@ -2766,7 +3527,7 @@
 		 */
 		if (SEQ_GT(th->th_seq+th->th_urp, tp->rcv_up)) {
 			tp->rcv_up = th->th_seq + th->th_urp;
-			so->so_oobmark = so->so_rcv.sb_cc +
+			so->so_oobmark = (so->so_rcv.sb_cc) +
 			    (tp->rcv_up - tp->rcv_nxt) - 1;
 			if (so->so_oobmark == 0)
 				so->so_rcv.sb_state |= SBS_RCVATMARK;
@@ -2799,17 +3560,21 @@
 
 	/*
 	 * Process the segment text, merging it into the TCP sequencing queue,
-	 * and arranging for acknowledgment of receipt if necessary.
+	 * and arranging for acknowledgement of receipt if necessary.
 	 * This process logically involves adjusting tp->rcv_wnd as data
 	 * is presented to the user (this happens in tcp_usrreq.c,
 	 * case PRU_RCVD).  If a FIN has already been received on this
 	 * connection then we just ignore the text.
 	 */
+
+
 	if ((tlen || (thflags & TH_FIN)) &&
 	    TCPS_HAVERCVDFIN(tp->t_state) == 0) {
 		tcp_seq save_start = th->th_seq;
 		m_adj(m, drop_hdrlen);	/* delayed header drop */
+
 		/*
+		 * XXXNJW: Need to adapt this comment
 		 * Insert segment which includes th into TCP reassembly queue
 		 * with control block tp.  Set thflags to whether reassembly now
 		 * includes a segment with FIN.  This handles the common case
@@ -2821,35 +3586,21 @@
 		 * immediately when segments are out of order (so
 		 * fast retransmit can work).
 		 */
-		if (th->th_seq == tp->rcv_nxt &&
-		    LIST_EMPTY(&tp->t_segq) &&
-		    TCPS_HAVEESTABLISHED(tp->t_state)) {
-			if (DELAY_ACK(tp))
-				tp->t_flags |= TF_DELACK;
-			else
+		    thflags = tcp_reass(tp, th, &tlen, m);
+			if (TCPS_HAVEESTABLISHED(tp->t_state) &&
+					!tp->t_segq->disordered) {
+				if (DELAY_ACK(tp))
+					tp->t_flags |= TF_DELACK;
+				else
+					tp->t_flags |= TF_ACKNOW;
+				TCPSTAT_INC(tcps_rcvpack);
+				TCPSTAT_ADD(tcps_rcvbyte, tlen);
+			} else {
+				// disordered bytes in list
+				// dont want to set FIN just yet
 				tp->t_flags |= TF_ACKNOW;
-			tp->rcv_nxt += tlen;
-			thflags = th->th_flags & TH_FIN;
-			TCPSTAT_INC(tcps_rcvpack);
-			TCPSTAT_ADD(tcps_rcvbyte, tlen);
-			ND6_HINT(tp);
-			SOCKBUF_LOCK(&so->so_rcv);
-			if (so->so_rcv.sb_state & SBS_CANTRCVMORE)
-				m_freem(m);
-			else
-				sbappendstream_locked(&so->so_rcv, m);
-			/* NB: sorwakeup_locked() does an implicit unlock. */
-			sorwakeup_locked(so);
-		} else {
-			/*
-			 * XXX: Due to the header drop above "th" is
-			 * theoretically invalid by now.  Fortunately
-			 * m_adj() doesn't actually frees any mbufs
-			 * when trimming from the head.
-			 */
-			thflags = tcp_reass(tp, th, &tlen, m);
-			tp->t_flags |= TF_ACKNOW;
-		}
+			}
+
 		if (tlen > 0 && (tp->t_flags & TF_SACK_PERMIT))
 			tcp_update_sack_list(tp, save_start, save_start + tlen);
 #if 0
@@ -3099,8 +3850,11 @@
 tcp_dooptions(struct tcpopt *to, u_char *cp, int cnt, int flags)
 {
 	int opt, optlen;
-
+	uint8_t subtype;
+
+	to->to_mopts.mpo_flags = 0;
 	to->to_flags = 0;
+	
 	for (; cnt > 0; cnt -= optlen, cp += optlen) {
 		opt = cp[0];
 		if (opt == TCPOPT_EOL)
@@ -3144,6 +3898,13 @@
 			    (char *)&to->to_tsecr, sizeof(to->to_tsecr));
 			to->to_tsecr = ntohl(to->to_tsecr);
 			break;
+		case TCPOPT_MPTCP:
+			bcopy((char *)cp + 2,
+					(char *)&subtype, sizeof(subtype));
+			if (optlen > MAX_MP_OPLEN)
+				continue;
+			mp_dosubtypes(to, subtype, cp, opt, optlen, flags);
+			break;
 #ifdef TCP_SIGNATURE
 		/*
 		 * XXX In order to reply to a host which has set the
